/*************************************************************************************
3D Data Visualization – News searched in Pompidou Centre Library from March 13rd to March 26th               
Tested in Processing 3                                    
 
Author: Weidi Zhang                            
Instruction for Interaction:

Press 'm' to view different Modes
Press 'p' to view different perspective
Press Arrow key to navigate the data – Zoom In, Zoom Out, Rotate (clockWise) (anti-clockwise)
Press Enter key to ON AND OFF to view search time distrubution on each date 
MOUSE CLICK To pause the animation 

 *************************************************************************************/
 
 
Table table;
int numRows, numColumns;
float[][] dataMatrix;
boolean horizontal = false;
boolean sculpture = true;
boolean mode = true;
float headerW=20;
float v, vH, vU, vUh, vUnit, vDep;
float xpos, ypos;
color black = color(0, 0, 0), grey=180, red=color(200, 7, 26, 255);
color white = color(245, 245, 245);
float strokeL = 1.5;
PFont Gotham;
PFont Lato; 
PFont LatoBold;
float unit=11;//space between two lines
float depthN=400;//width*20;//depth
float zpos;
float timeN=25; // rect length
float ang, ang2, ang3;
float col;
int unitH= 25;//header
int frame;
int vFrame;
float frameBar;
Header hD;
drawRect dR;

void setup() {
  fullScreen(P3D);
  surface.setResizable(true);
  Gotham = createFont("Gotham-Bold.otf", 32);
  Lato = createFont("Lato-Regular.ttf", 32);
  LatoBold = createFont("Lato-Bold.ttf", 60);
  hD =  new Header();
  dR = new drawRect();
  //setup Table
  table = loadTable ("News.csv", "header");
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  dataMatrix = new float [numColumns][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);

  for (int i=0; i<numColumns; i++) {
    for (int j=0; j<numRows; j++) {
      dataMatrix[i][j] = table.getFloat(j, i);
    }
  }
}
void draw() {
  if (mode) {
    ang3=90;
  } else {
    ang3=0;
  }
  //unit = 20+vUnit;
  //depthN = 1600+vDep;
  background(black);
  pushMatrix(); 

  dR.display();
  popMatrix();
  //header
  hint(DISABLE_DEPTH_TEST); 
  hD.display();
  hD.timeline();
  hD.button();
  hint(ENABLE_DEPTH_TEST);
}